Some fonts are lighter weight after updating from macOS 10.13 to 10.14 Mojave

VERIFIED FIXED in Firefox 65

Status

()

defect
P2
normal
VERIFIED FIXED
8 months ago
3 months ago

People

(Reporter: cpeterson, Assigned: lsalzman)

Tracking

(Blocks 1 bug, {regression})

unspecified
mozilla66
Unspecified
macOS
Points:
---
Dependency tree / graph

Firefox Tracking Flags

(firefox-esr60 wontfix, firefox62 wontfix, firefox63 wontfix, firefox64 unaffected, firefox65+ fixed, firefox66+ verified)

Details

Attachments

(4 attachments)

Reporter

Description

8 months ago
After updating from macOS 10.13 (High Sierra) to 10.14 (Mojave), some fonts are lighter weight in Firefox and Chrome than in Safari.

Examples:
* Bugzilla's text
* The body text on https://searchfox.org/
* The blame tool tip text and monospace code text on https://searchfox.org/mozilla-central/source/README.txt

See the attached screenshot show Firefox, Safari, and Chrome side-by-side.
Reporter

Comment 1

8 months ago
I've read the macOS 10.14 disabled subpixel antialiasing for non-Retina displays, but I'm using a MacBook Pro with a Retina display so I assume that is not relevant to these font weight differences.

Comment 2

7 months ago
This is indeed a problem on Mojave for all apps using the Skia library for font rendering. It has already been patched in latest Chromium Canary (https://bugs.chromium.org/p/chromium/issues/detail?id=858861) and I've opened a bug on Electron's bug tracker as well (https://github.com/electron/electron/issues/14948).
Priority: -- → P2

Comment 3

7 months ago
It seems that the problem of font rendering not only affects the non-retina screen. For example, the body part of the URL below. I put its display in the attachment.

https://www.zcool.com.cn/work/ZMzA1Nzg5NjA=.html

I also found related bugs on vscode.
https://github.com/Microsoft/vscode/issues/59887

Comment 4

4 months ago

It seems Firefox now has improved font rendering on macOS Mojave! (tested with default font smoothing of Mojave: defaults write -g CGFontRenderingFontSmoothingDisabled -bool YES)

The improvement is noticed on Firefox stable channel 64.0.2 (64-bit)

But at the same time Firefox developer edition 65.0b11 (64-bit) does not have this improvement yet.

Whatever you've done on 64.0.2, please keep this improvement in future releases also.

Still not exactly like Safari's font rendering, but comparing with Chrome's font the improvement is great.

Thanks

Reporter

Comment 5

4 months ago

(In reply to Minkul from comment #4)

The improvement is noticed on Firefox stable channel 64.0.2 (64-bit)

But at the same time Firefox developer edition 65.0b11 (64-bit) does not have this improvement yet.

Whatever you've done on 64.0.2, please keep this improvement in future releases also.

Thanks. Your screenshots clearly show the differences. However, I just tested on my MacBook Pro Retina running Mojave and see different results. I see the same lightweight fonts in Firefox 64, 65 Beta, and 66 Nightly. (If I enable WebRender in Nightly using gfx.webrender.all, I see heavier weight fonts, but not has heavy as Safari's.)

If you can reproduce the 64/65 font differences when using a new Firefox user profile, can you try using the mozregression script to bisect the Firefox builds between 64 and 65 until you've found the build that caused the regression in 65? Then we can try to undo that font change.

https://mozilla.github.io/mozregression/

Comment 6

4 months ago

Here is the result from mozregression:

64: 2018-10-22
65: 2018-12-10

(venv) Minkuls-Mac-mini:mozreg minkul$ mozregression --good 2018-10-22 --bad 2018-12-10 --persist temp


You should use a config file. Please use the --write-config command line flag to help you create one.


0:08.22 INFO: Testing good and bad builds to ensure that they are really good and bad...
0:08.22 INFO: Downloading build from: https://archive.mozilla.org/pub/firefox/nightly/2018/10/2018-10-22-22-07-34-mozilla-central/firefox-65.0a1.en-US.mac.dmg
===== Downloaded 100% =====
2:14.73 INFO: Running mozilla-central build for 2018-10-22
2:38.03 INFO: Launching /private/var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmp8O5zpl/Firefox Nightly.app/Contents/MacOS/firefox
2:38.03 INFO: Application command: /private/var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmp8O5zpl/Firefox Nightly.app/Contents/MacOS/firefox -foreground -profile /var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpItFcbU.mozrunner
2:38.05 INFO: application_buildid: 20181022220734
2:38.05 INFO: application_changeset: 2872e7a3606d6108874930a1eb4062c74bad0e9e
2:38.05 INFO: application_name: Firefox
2:38.05 INFO: application_repository: https://hg.mozilla.org/mozilla-central
2:38.05 INFO: application_version: 65.0a1
Was this nightly build good, bad, or broken? (type 'good', 'bad', 'skip', 'retry' or 'exit' and press Enter): good
3:14.03 INFO: Downloading build from: https://archive.mozilla.org/pub/firefox/nightly/2018/12/2018-12-10-22-05-53-mozilla-central/firefox-66.0a1.en-US.mac.dmg
===== Downloaded 100% =====
4:37.93 INFO: Running mozilla-central build for 2018-12-10
4:59.45 INFO: Launching /private/var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpiVNzv9/Firefox Nightly.app/Contents/MacOS/firefox
4:59.45 INFO: Application command: /private/var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpiVNzv9/Firefox Nightly.app/Contents/MacOS/firefox -foreground -profile /var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpmPxMXA.mozrunner
4:59.47 INFO: application_buildid: 20181210220553
4:59.47 INFO: application_changeset: 13f891b92db19ea8ec85ef329eff7a793c8b368f
4:59.47 INFO: application_name: Firefox
4:59.47 INFO: application_repository: https://hg.mozilla.org/mozilla-central
4:59.47 INFO: application_version: 66.0a1
Was this nightly build good, bad, or broken? (type 'good', 'bad', 'skip', 'retry' or 'exit' and press Enter): bad
6:35.16 INFO: Good and bad builds are correct. Let's continue the bisection.
6:35.16 INFO: Pushlog:
https://hg.mozilla.org/mozilla-central/pushloghtml?fromchange=2872e7a3606d6108874930a1eb4062c74bad0e9e&tochange=13f891b92db19ea8ec85ef329eff7a793c8b368f

6:35.17 INFO: Downloading build from: https://archive.mozilla.org/pub/firefox/nightly/2018/11/2018-11-16-22-00-54-mozilla-central/firefox-65.0a1.en-US.mac.dmg
===== Downloaded 100% =====
7:13.53 INFO: Running mozilla-central build for 2018-11-16
7:38.12 INFO: Launching /private/var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpEHlMbg/Firefox Nightly.app/Contents/MacOS/firefox
7:38.12 INFO: Application command: /private/var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpEHlMbg/Firefox Nightly.app/Contents/MacOS/firefox -foreground -profile /var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpmo44co.mozrunner
7:38.15 INFO: application_buildid: 20181116220054
7:38.15 INFO: application_changeset: 7154eb3601f3b89ef5b8e559c9f2bae57f6d59f3
7:38.15 INFO: application_name: Firefox
7:38.15 INFO: application_repository: https://hg.mozilla.org/mozilla-central
7:38.15 INFO: application_version: 65.0a1
Was this nightly build good, bad, or broken? (type 'good', 'bad', 'skip', 'retry' or 'exit' and press Enter): bad
7:57.84 INFO: Narrowed nightly regression window from [2018-10-22, 2018-12-10] (49 days) to [2018-10-22, 2018-11-16] (25 days) (~4 steps left)
7:57.84 INFO: Pushlog:
https://hg.mozilla.org/mozilla-central/pushloghtml?fromchange=2872e7a3606d6108874930a1eb4062c74bad0e9e&tochange=7154eb3601f3b89ef5b8e559c9f2bae57f6d59f3

7:57.84 INFO: Downloading build from: https://archive.mozilla.org/pub/firefox/nightly/2018/11/2018-11-04-22-01-00-mozilla-central/firefox-65.0a1.en-US.mac.dmg
===== Downloaded 100% =====
9:51.01 INFO: Running mozilla-central build for 2018-11-04
10:14.06 INFO: Launching /private/var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmplA4AQn/Firefox Nightly.app/Contents/MacOS/firefox
10:14.06 INFO: Application command: /private/var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmplA4AQn/Firefox Nightly.app/Contents/MacOS/firefox -foreground -profile /var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmp8UB7_U.mozrunner
10:14.08 INFO: application_buildid: 20181104220100
10:14.08 INFO: application_changeset: 04b755bbff848f7e245ae86c3fa2c5d6c6bad191
10:14.08 INFO: application_name: Firefox
10:14.08 INFO: application_repository: https://hg.mozilla.org/mozilla-central
10:14.08 INFO: application_version: 65.0a1
Was this nightly build good, bad, or broken? (type 'good', 'bad', 'skip', 'retry', 'back' or 'exit' and press Enter): bad
10:33.39 INFO: Narrowed nightly regression window from [2018-10-22, 2018-11-16] (25 days) to [2018-10-22, 2018-11-04] (13 days) (~3 steps left)
10:33.39 INFO: Pushlog:
https://hg.mozilla.org/mozilla-central/pushloghtml?fromchange=2872e7a3606d6108874930a1eb4062c74bad0e9e&tochange=04b755bbff848f7e245ae86c3fa2c5d6c6bad191

10:33.39 INFO: Downloading build from: https://archive.mozilla.org/pub/firefox/nightly/2018/10/2018-10-29-23-01-49-mozilla-central/firefox-65.0a1.en-US.mac.dmg
===== Downloaded 100% =====
12:24.90 INFO: Running mozilla-central build for 2018-10-29
12:48.23 INFO: Launching /private/var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpE1te9m/Firefox Nightly.app/Contents/MacOS/firefox
12:48.23 INFO: Application command: /private/var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpE1te9m/Firefox Nightly.app/Contents/MacOS/firefox -foreground -profile /var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpm80kKr.mozrunner
12:48.25 INFO: application_buildid: 20181029230149
12:48.25 INFO: application_changeset: 4c7772c170a1848c4e57fea0087c351fd2288859
12:48.25 INFO: application_name: Firefox
12:48.25 INFO: application_repository: https://hg.mozilla.org/mozilla-central
12:48.25 INFO: application_version: 65.0a1
Was this nightly build good, bad, or broken? (type 'good', 'bad', 'skip', 'retry', 'back' or 'exit' and press Enter): good
13:17.49 INFO: Narrowed nightly regression window from [2018-10-22, 2018-11-04] (13 days) to [2018-10-29, 2018-11-04] (6 days) (~2 steps left)
13:17.49 INFO: Pushlog:
https://hg.mozilla.org/mozilla-central/pushloghtml?fromchange=4c7772c170a1848c4e57fea0087c351fd2288859&tochange=04b755bbff848f7e245ae86c3fa2c5d6c6bad191

13:17.49 INFO: Downloading build from: https://archive.mozilla.org/pub/firefox/nightly/2018/11/2018-11-01-22-00-58-mozilla-central/firefox-65.0a1.en-US.mac.dmg
===== Downloaded 100% =====
15:03.17 INFO: Running mozilla-central build for 2018-11-01
15:25.45 INFO: Launching /private/var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpFtrVdy/Firefox Nightly.app/Contents/MacOS/firefox
15:25.45 INFO: Application command: /private/var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpFtrVdy/Firefox Nightly.app/Contents/MacOS/firefox -foreground -profile /var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpJhvAlF.mozrunner
15:25.47 INFO: application_buildid: 20181101220058
15:25.47 INFO: application_changeset: 182a1b088330a2d72310ae2561004d955571e236
15:25.47 INFO: application_name: Firefox
15:25.47 INFO: application_repository: https://hg.mozilla.org/mozilla-central
15:25.47 INFO: application_version: 65.0a1
Was this nightly build good, bad, or broken? (type 'good', 'bad', 'skip', 'retry', 'back' or 'exit' and press Enter): bad
15:41.99 INFO: Narrowed nightly regression window from [2018-10-29, 2018-11-04] (6 days) to [2018-10-29, 2018-11-01] (3 days) (~1 steps left)
15:41.99 INFO: Pushlog:
https://hg.mozilla.org/mozilla-central/pushloghtml?fromchange=4c7772c170a1848c4e57fea0087c351fd2288859&tochange=182a1b088330a2d72310ae2561004d955571e236

15:41.99 INFO: Downloading build from: https://archive.mozilla.org/pub/firefox/nightly/2018/10/2018-10-31-22-35-03-mozilla-central/firefox-65.0a1.en-US.mac.dmg
===== Downloaded 100% =====
17:45.80 INFO: Running mozilla-central build for 2018-10-31
18:05.36 INFO: Launching /private/var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpAeWYEK/Firefox Nightly.app/Contents/MacOS/firefox
18:05.36 INFO: Application command: /private/var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpAeWYEK/Firefox Nightly.app/Contents/MacOS/firefox -foreground -profile /var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpWZ7dJ7.mozrunner
18:05.39 INFO: application_buildid: 20181031223503
18:05.39 INFO: application_changeset: 7e4afca2ca929a07128419874845a94c2ff9aa3d
18:05.39 INFO: application_name: Firefox
18:05.39 INFO: application_repository: https://hg.mozilla.org/mozilla-central
18:05.39 INFO: application_version: 65.0a1
Was this nightly build good, bad, or broken? (type 'good', 'bad', 'skip', 'retry', 'back' or 'exit' and press Enter): bad
18:22.16 INFO: Narrowed nightly regression window from [2018-10-29, 2018-11-01] (3 days) to [2018-10-29, 2018-10-31] (2 days) (~1 steps left)
18:22.16 INFO: Pushlog:
https://hg.mozilla.org/mozilla-central/pushloghtml?fromchange=4c7772c170a1848c4e57fea0087c351fd2288859&tochange=7e4afca2ca929a07128419874845a94c2ff9aa3d

18:22.16 INFO: Downloading build from: https://archive.mozilla.org/pub/firefox/nightly/2018/10/2018-10-30-22-40-27-mozilla-central/firefox-65.0a1.en-US.mac.dmg
===== Downloaded 100% =====
20:04.94 INFO: Running mozilla-central build for 2018-10-30
20:26.06 INFO: Launching /private/var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpp6vx2W/Firefox Nightly.app/Contents/MacOS/firefox
20:26.07 INFO: Application command: /private/var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpp6vx2W/Firefox Nightly.app/Contents/MacOS/firefox -foreground -profile /var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpahd6rL.mozrunner
20:26.08 INFO: application_buildid: 20181030224027
20:26.08 INFO: application_changeset: be32f4014f92d0ab717621997e0d36c9bc1c479b
20:26.08 INFO: application_name: Firefox
20:26.08 INFO: application_repository: https://hg.mozilla.org/mozilla-central
20:26.08 INFO: application_version: 65.0a1
Was this nightly build good, bad, or broken? (type 'good', 'bad', 'skip', 'retry', 'back' or 'exit' and press Enter): good
20:56.00 INFO: Narrowed nightly regression window from [2018-10-29, 2018-10-31] (2 days) to [2018-10-30, 2018-10-31] (1 days) (~0 steps left)
20:56.00 INFO: Got as far as we can go bisecting nightlies...
20:56.00 INFO: Last good revision: be32f4014f92d0ab717621997e0d36c9bc1c479b (2018-10-30)
20:56.00 INFO: First bad revision: 7e4afca2ca929a07128419874845a94c2ff9aa3d (2018-10-31)
20:56.00 INFO: Pushlog:
https://hg.mozilla.org/mozilla-central/pushloghtml?fromchange=be32f4014f92d0ab717621997e0d36c9bc1c479b&tochange=7e4afca2ca929a07128419874845a94c2ff9aa3d

20:56.00 INFO: Switching bisection method to taskcluster
20:56.00 INFO: Getting mozilla-central builds between be32f4014f92d0ab717621997e0d36c9bc1c479b and 7e4afca2ca929a07128419874845a94c2ff9aa3d
21:08.58 INFO: Pushlog:
https://hg.mozilla.org/mozilla-central/pushloghtml?fromchange=be32f4014f92d0ab717621997e0d36c9bc1c479b&tochange=7e4afca2ca929a07128419874845a94c2ff9aa3d

21:08.58 INFO: Downloading build from: https://queue.taskcluster.net/v1/task/KfMTvfBzRkS2B5NshPQ9lA/runs/0/artifacts/public%2Fbuild%2Ftarget.dmg
===== Downloaded 100% =====
23:15.79 INFO: Running mozilla-central build built on 2018-10-31 10:55:10.703000, revision 0029fe1e
23:39.06 INFO: Launching /private/var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpUQIsqW/Firefox Nightly.app/Contents/MacOS/firefox
23:39.06 INFO: Application command: /private/var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpUQIsqW/Firefox Nightly.app/Contents/MacOS/firefox -foreground -profile /var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpIWVTv2.mozrunner
23:39.07 INFO: application_buildid: 20181031094543
23:39.07 INFO: application_changeset: 0029fe1e56d7870fac39504a9c212775e2939f58
23:39.07 INFO: application_name: Firefox
23:39.07 INFO: application_repository: https://hg.mozilla.org/mozilla-central
23:39.07 INFO: application_version: 65.0a1
Was this inbound build good, bad, or broken? (type 'good', 'bad', 'skip', 'retry' or 'exit' and press Enter): bad
23:57.38 INFO: Narrowed inbound regression window from [be32f401, 7e4afca2] (9 builds) to [be32f401, 0029fe1e] (5 builds) (~2 steps left)
23:57.38 INFO: Pushlog:
https://hg.mozilla.org/mozilla-central/pushloghtml?fromchange=be32f4014f92d0ab717621997e0d36c9bc1c479b&tochange=0029fe1e56d7870fac39504a9c212775e2939f58

23:57.38 INFO: Downloading build from: https://queue.taskcluster.net/v1/task/Hb44OA2pTfKm50_zDt5gOw/runs/0/artifacts/public%2Fbuild%2Ftarget.dmg
===== Downloaded 100% =====
25:51.54 INFO: Running mozilla-central build built on 2018-10-31 06:33:29.580000, revision 1c5ee1a2
26:11.66 INFO: Launching /private/var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmplDvrAB/Firefox Nightly.app/Contents/MacOS/firefox
26:11.66 INFO: Application command: /private/var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmplDvrAB/Firefox Nightly.app/Contents/MacOS/firefox -foreground -profile /var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpbWY4lU.mozrunner
26:11.67 INFO: application_buildid: 20181031050854
26:11.67 INFO: application_changeset: 1c5ee1a29757dc654cb24840ed649ca0eb0bfc06
26:11.67 INFO: application_name: Firefox
26:11.67 INFO: application_repository: https://hg.mozilla.org/mozilla-central
26:11.67 INFO: application_version: 65.0a1
Was this inbound build good, bad, or broken? (type 'good', 'bad', 'skip', 'retry', 'back' or 'exit' and press Enter): good
27:08.46 INFO: Narrowed inbound regression window from [be32f401, 0029fe1e] (5 builds) to [1c5ee1a2, 0029fe1e] (3 builds) (~1 steps left)
27:08.46 INFO: Pushlog:
https://hg.mozilla.org/mozilla-central/pushloghtml?fromchange=1c5ee1a29757dc654cb24840ed649ca0eb0bfc06&tochange=0029fe1e56d7870fac39504a9c212775e2939f58

27:08.46 INFO: Downloading build from: https://queue.taskcluster.net/v1/task/EvkZKkzTQk2IJrC5iP5QjQ/runs/0/artifacts/public%2Fbuild%2Ftarget.dmg
===== Downloaded 100% =====
28:44.02 INFO: Running mozilla-central build built on 2018-10-31 10:41:42.402000, revision 4774ae23
32:14.93 INFO: Launching /private/var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpkuDgxX/Firefox Nightly.app/Contents/MacOS/firefox
32:14.93 INFO: Application command: /private/var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpkuDgxX/Firefox Nightly.app/Contents/MacOS/firefox -foreground -profile /var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpFU5G0r.mozrunner
32:14.93 INFO: application_buildid: 20181031094254
32:14.93 INFO: application_changeset: 4774ae235f5f816562b4cc99ae8bed81e7c30e05
32:14.93 INFO: application_name: Firefox
32:14.94 INFO: application_repository: https://hg.mozilla.org/mozilla-central
32:14.94 INFO: application_version: 65.0a1
Was this inbound build good, bad, or broken? (type 'good', 'bad', 'skip', 'retry', 'back' or 'exit' and press Enter): good
32:37.50 INFO: Narrowed inbound regression window from [1c5ee1a2, 0029fe1e] (3 builds) to [4774ae23, 0029fe1e] (2 builds) (~1 steps left)
32:37.51 INFO: No more inbound revisions, bisection finished.
32:37.51 INFO: Last good revision: 4774ae235f5f816562b4cc99ae8bed81e7c30e05
32:37.51 INFO: First bad revision: 0029fe1e56d7870fac39504a9c212775e2939f58
32:37.51 INFO: Pushlog:
https://hg.mozilla.org/mozilla-central/pushloghtml?fromchange=4774ae235f5f816562b4cc99ae8bed81e7c30e05&tochange=0029fe1e56d7870fac39504a9c212775e2939f58

32:40.63 INFO: ************* Switching to mozilla-inbound
32:40.63 INFO: Getting mozilla-inbound builds between 8e3921cb196c5c0154fc855cb5151e21a293fa7c and f7ec22650157429d62ff51ac1aeeee51e78a35bd
32:49.92 INFO: Pushlog:
https://hg.mozilla.org/integration/mozilla-inbound/pushloghtml?fromchange=8e3921cb196c5c0154fc855cb5151e21a293fa7c&tochange=f7ec22650157429d62ff51ac1aeeee51e78a35bd

32:49.93 INFO: Downloading build from: https://queue.taskcluster.net/v1/task/ZqxH_UYbSfiX2x9QX_GtWA/runs/0/artifacts/public%2Fbuild%2Ftarget.dmg
===== Downloaded 100% =====
34:55.59 INFO: Running mozilla-inbound build built on 2018-10-31 03:12:01.701000, revision 10a10129
35:15.07 INFO: Launching /private/var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpZtBQnH/Firefox Nightly.app/Contents/MacOS/firefox
35:15.07 INFO: Application command: /private/var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpZtBQnH/Firefox Nightly.app/Contents/MacOS/firefox -foreground -profile /var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpdhY6Wv.mozrunner
35:15.08 INFO: application_buildid: 20181031021226
35:15.08 INFO: application_changeset: 10a1012904a301011e98d9e3a413476f250cf081
35:15.08 INFO: application_name: Firefox
35:15.08 INFO: application_repository: https://hg.mozilla.org/integration/mozilla-inbound
35:15.08 INFO: application_version: 65.0a1
Was this inbound build good, bad, or broken? (type 'good', 'bad', 'skip', 'retry' or 'exit' and press Enter): good
35:35.31 INFO: Narrowed inbound regression window from [8e3921cb, f7ec2265] (7 builds) to [10a10129, f7ec2265] (4 builds) (~2 steps left)
35:35.31 INFO: Pushlog:
https://hg.mozilla.org/integration/mozilla-inbound/pushloghtml?fromchange=10a1012904a301011e98d9e3a413476f250cf081&tochange=f7ec22650157429d62ff51ac1aeeee51e78a35bd

35:35.31 INFO: Downloading build from: https://queue.taskcluster.net/v1/task/dI1Zt9bnT4ubUULgMLa9FA/runs/1/artifacts/public%2Fbuild%2Ftarget.dmg
===== Downloaded 100% =====
38:07.97 INFO: Running mozilla-inbound build built on 2018-10-31 03:40:01.942000, revision 8ae21741
38:27.44 INFO: Launching /private/var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmphedVW8/Firefox Nightly.app/Contents/MacOS/firefox
38:27.44 INFO: Application command: /private/var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmphedVW8/Firefox Nightly.app/Contents/MacOS/firefox -foreground -profile /var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmpsCV1jp.mozrunner
38:27.45 INFO: application_buildid: 20181031023859
38:27.45 INFO: application_changeset: 8ae21741b57cda1f74dd4cec977cb5d0b240277e
38:27.45 INFO: application_name: Firefox
38:27.45 INFO: application_repository: https://hg.mozilla.org/integration/mozilla-inbound
38:27.45 INFO: application_version: 65.0a1
Was this inbound build good, bad, or broken? (type 'good', 'bad', 'skip', 'retry', 'back' or 'exit' and press Enter): bad
38:46.06 INFO: Narrowed inbound regression window from [10a10129, f7ec2265] (4 builds) to [10a10129, 8ae21741] (3 builds) (~1 steps left)
38:46.06 INFO: Pushlog:
https://hg.mozilla.org/integration/mozilla-inbound/pushloghtml?fromchange=10a1012904a301011e98d9e3a413476f250cf081&tochange=8ae21741b57cda1f74dd4cec977cb5d0b240277e

38:46.06 INFO: Downloading build from: https://queue.taskcluster.net/v1/task/eL1qOxCnSHi0FAVVAmYAIg/runs/0/artifacts/public%2Fbuild%2Ftarget.dmg
===== Downloaded 100% =====
40:36.08 INFO: Running mozilla-inbound build built on 2018-10-31 03:12:51.469000, revision 8ca1ac55
40:54.81 INFO: Launching /private/var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmppLD7zs/Firefox Nightly.app/Contents/MacOS/firefox
40:54.81 INFO: Application command: /private/var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmppLD7zs/Firefox Nightly.app/Contents/MacOS/firefox -foreground -profile /var/folders/0q/zcgzp3496vs88nn7bf1wlrtm0000gn/T/tmps8lxPz.mozrunner
40:54.81 INFO: application_buildid: 20181031021908
40:54.81 INFO: application_changeset: 8ca1ac55ea7954a15da6da6262d2568f307710ff
40:54.81 INFO: application_name: Firefox
40:54.81 INFO: application_repository: https://hg.mozilla.org/integration/mozilla-inbound
40:54.81 INFO: application_version: 65.0a1
Was this inbound build good, bad, or broken? (type 'good', 'bad', 'skip', 'retry', 'back' or 'exit' and press Enter): bad
41:08.34 INFO: Narrowed inbound regression window from [10a10129, 8ae21741] (3 builds) to [10a10129, 8ca1ac55] (2 builds) (~1 steps left)
41:08.34 INFO: No more inbound revisions, bisection finished.
41:08.34 INFO: Last good revision: 10a1012904a301011e98d9e3a413476f250cf081
41:08.34 INFO: First bad revision: 8ca1ac55ea7954a15da6da6262d2568f307710ff
41:08.34 INFO: Pushlog:
https://hg.mozilla.org/integration/mozilla-inbound/pushloghtml?fromchange=10a1012904a301011e98d9e3a413476f250cf081&tochange=8ca1ac55ea7954a15da6da6262d2568f307710ff

Reporter

Comment 7

4 months ago

(In reply to Minkul from comment #6)

Here is the result from mozregression:
...
41:08.34 INFO: Last good revision: 10a1012904a301011e98d9e3a413476f250cf081
41:08.34 INFO: First bad revision: 8ca1ac55ea7954a15da6da6262d2568f307710ff
41:08.34 INFO: Pushlog:
https://hg.mozilla.org/integration/mozilla-inbound/pushloghtml?fromchange=10a1012904a301011e98d9e3a413476f250cf081&tochange=8ca1ac55ea7954a15da6da6262d2568f307710ff

@ Minkul: Thanks! This is very helpful. Are you using a Retina or non-Retina (HiDPI) display?

@ Lee: it looks like Skia m71 (bug 1502152) in Firefox 65 regressed font weight compared to Firefox 64 on macOS 10.14 Mojave. See the screenshot in comment 4.

Comment 2 points to a Chromium bug fix for Skia. Is there anything we can do in Firefox?

Flags: needinfo?(lsalzman)
See Also: → 1502152

Comment 8

4 months ago

I tested using non-Retina (1920 x 1080) display.

Assignee

Comment 9

4 months ago

Skia m71 has the fix that was mentioned in comment 2 rolled into it. If anything, it should resolve the issue?

Flags: needinfo?(lsalzman)
Assignee

Comment 10

4 months ago

The Skia m71 update in bug 1502152 should have essentially fixed the problem via included revision https://skia.googlesource.com/skia/+/6112f0b068b3101f42d53c53345a761a69a46c20%5E%21/#F0

That fix, however, included a bug that disabled gamma conversion, making fonts look thinner. This was later fixed after m71 in the upstream revision https://skia.googlesource.com/skia/+/16d00eeef7d18dcfd28725bcb4c15dad633ab7eb%5E%21/#F0

Let's cherry-pick that fix.

Assignee: nobody → lsalzman
Status: NEW → ASSIGNED
Attachment #9037387 - Flags: review?(mstange)
Comment on attachment 9037387 [details] [diff] [review]
cherry-pick Skia fix for Mac font gamma

r+ if you link to the skia changeset in the commit message and maybe repeat that changeset's commit message here

Thanks!
Attachment #9037387 - Flags: review?(mstange) → review+

Comment 12

4 months ago
Pushed by lsalzman@mozilla.com:
https://hg.mozilla.org/integration/mozilla-inbound/rev/e74eb5b1a8c2
cherry-pick Skia fix for Mac font gamma. r=mstange
Reporter

Comment 13

4 months ago

(In reply to Lee Salzman [:lsalzman] from comment #10)

Created attachment 9037387 [details] [diff] [review]
That fix, however, included a bug that disabled gamma conversion, making fonts look thinner. This was later fixed after m71 in the upstream revision https://skia.googlesource.com/skia/+/16d00eeef7d18dcfd28725bcb4c15dad633ab7eb%5E%21/#F0

Let's cherry-pick that fix.

Lee, thanks for finding that Skia fix.

Minkul, thanks again for using mozregression to pinpoint the exact cause of the regression in Firefox 65.

65=wontfix because, without less than two weeks left in the 65 beta cycle, I think it's too late to uplift a fix for a cosmetic issue.

Assignee

Comment 14

4 months ago

(In reply to Chris Peterson [:cpeterson] from comment #13)

(In reply to Lee Salzman [:lsalzman] from comment #10)

Created attachment 9037387 [details] [diff] [review]
That fix, however, included a bug that disabled gamma conversion, making fonts look thinner. This was later fixed after m71 in the upstream revision https://skia.googlesource.com/skia/+/16d00eeef7d18dcfd28725bcb4c15dad633ab7eb%5E%21/#F0

Let's cherry-pick that fix.

Lee, thanks for finding that Skia fix.

Minkul, thanks again for using mozregression to pinpoint the exact cause of the regression in Firefox 65.

65=wontfix because, without less than two weeks left in the 65 beta cycle, I think it's too late to uplift a fix for a cosmetic issue.

Even given that, I think the fix is trivial enough, and I am fairly sure how it regressed given the nature of it. It was predictable enough upon inspection that I independently found the fix myself before checking to see if upstream did the same.

I think so long as we just have a couple people verify the fix in nightly it should be safe to uplift to beta, even on short notice. The alternative is to let a known avoidable regression in appearance slip into release.

Reporter

Comment 15

4 months ago

[Tracking Requested - why for this release]:

Relman, this bug is a font regression in 65. You know how sensitive macOS users (like me) can be about their fonts. :)

This bug's history has morphed: I originally filed it for a font problem on Retina displays caused by upgrading to macOS 10.14 Mojave. The Retina problem was fixed by Skia bug 1502152, but the fix caused a similar font regression on non-Retina displays. Lee's patch in this bug fixes that non-Retina regression by cherry-picking a one line fix from upstream Skia.

(In reply to Lee Salzman [:lsalzman] from comment #14)

I think so long as we just have a couple people verify the fix in nightly it should be safe to uplift to beta, even on short notice. The alternative is to let a known avoidable regression in appearance slip into release.

As a Mac user and the person originally who filed this bug, that sounds good to me. :)

Comment 16

4 months ago
bugherder
Status: ASSIGNED → RESOLVED
Last Resolved: 4 months ago
Resolution: --- → FIXED
Target Milestone: --- → mozilla66

So this is kind of a mess now :. Do we need a follow-up bug for fixing ESR60 for the originally-reported problem? Also, please request Beta approval on this patch if you feel it needs uplift - tracking+ doesn't guarantee that.

Reporter

Comment 18

4 months ago

(In reply to Ryan VanderMeulen [:RyanVM] from comment #17)

So this is kind of a mess now :. Do we need a follow-up bug for fixing ESR60 for the originally-reported problem?

I just confirmed that ESR 60 is affected, but I don't think this issue is serious enough to warrant an ESR uplift. IIUC, we would need to uplift all of Skia m71 (bug 1502152) plus this bug's patch to ESR 60.

@ Minkul, can you please test whether the latest Firefox 66 Nightly fixes the fonts on your non-Retina display?

I confirmed on my Retina MacBook Pro that fonts (on Wikipedia) now look heavier in 66 Nightly than 65 Beta (which look a little heavier than 64 Release and ESR 60). For comparison, Safari's font weight looks like it is half-way between Firefox 65's and 66's weights. I actually prefer 65's lighter weight on my Retina display, but the differences are small and subjective. :)

Also, please request Beta approval on this patch if you feel it needs uplift - tracking+ doesn't guarantee that.

I just asked for 65 tracking to give Relman a heads-up about this fix. Lee recommended confirming the fix on Nightly before requesting uplift.

Comment 19

4 months ago

(In reply to Chris Peterson [:cpeterson] from comment #18)

@ Minkul, can you please test whether the latest Firefox 66 Nightly fixes the fonts on your non-Retina display?

@ Chris, yes Firefox Nightly 66.0a1 (2019-01-18) fixes the fonts on non-Retina display.

Reporter

Comment 20

4 months ago
Comment on attachment 9037387 [details] [diff] [review]
cherry-pick Skia fix for Mac font gamma

[Beta/Release Uplift Approval Request]

Feature/Bug causing the regression: Bug 1502152

User impact if declined: Font weights will be too light on macOS non-Retina displays.

I originally filed this bug for a font weights being too light on macOS *Retina* displays caused by upgrading to macOS 10.14 Mojave. The Retina problem was fixed in Firefox 65 by Skia bug 1502152, but that fix caused a font weight regression on *non-Retina* displays. Lee's patch in this bug fixes the non-Retina regression by cherry-picking a one line fix from upstream Skia.

In comment 14, Lee says: "I think the fix is trivial enough, and I am fairly sure how it regressed given the nature of it. It was predictable enough upon inspection that I independently found the fix myself before checking to see if upstream did the same. I think so long as we just have a couple people verify the fix in nightly it should be safe to uplift to beta, even on short notice. The alternative is to let a known avoidable regression in appearance slip into release.""

Is this code covered by automated tests?: No

Has the fix been verified in Nightly?: Yes

Needs manual test from QE?: No

If yes, steps to reproduce: 

List of other uplifts needed: None

Risk to taking this patch: Low

Why is the change risky/not risky? (and alternatives if risky): This fix cherry picks a one-line, macOS-specific fix from upstream Skia.

String changes made/needed: None
Attachment #9037387 - Flags: approval-mozilla-beta?
Comment on attachment 9037387 [details] [diff] [review]
cherry-pick Skia fix for Mac font gamma

skia regression fix, approved for 65.0 rc1
Flags: needinfo?(lsalzman)
Attachment #9037387 - Flags: approval-mozilla-beta? → approval-mozilla-release+

Comment 23

4 months ago

Hello there!

After noticing fonts felt "too bold" now in the last Firefox Developer Edition (66.0b1) I posted something about this including a comparing screenshot on Reddit ( https://www.reddit.com/r/firefox/comments/aj3p2v/fonts_too_bold_since_firefox_devedition_660b1/ ) and with the help from another user there I found this Report.

In my opinion this fix makes reading webpages worse on Retina Displays than it was (I'd say you fixed something that wasn't broken). I tested it with the default Display on a Retina MacBook & iMac and the latest Version of macOS Mojave. The fonts after the Fix in Firefox look a bit blurry and too bold now in my opinion and especially smaller texts are harder to read for me now than before.

I also tried to compare it to Safari and even though the fonts in Safari are a little bit bolder than Firefox did it before (in the current stable), I still feel that Firefox with this new fix makes them even bolder than Safari (blurry?). The rendering in the current stable version is in my opinion much better (on Retina Display at last, don't know if this is also the case on external Monitors or non-Retina Devices, I have no possibility to test that).

I also tried to compare it to Chrome: This one shows the fonts like Firefox does it in the current stable and in my opinion it seems this has a much better readability on Retina Displays.

I hope you test this again, especially with Retina Displays, because I think this change reduces readability instead of improving it and I have the feeling the font-weight definition drifts too far apart (even from Safari).

Reporter

Comment 24

4 months ago

Lee, what do you think about Christian's point? Should we get feedback from the Firefox UX team?

As I noted in comment 18, like Christian, on my Retina display, I personally preferred 65's font weight with Skia m71 before the SmoothBehavior patch, but these differences are subjective. :)

Flags: needinfo?(lsalzman)
Assignee

Comment 25

4 months ago

(In reply to Chris Peterson [:cpeterson] from comment #24)

Lee, what do you think about Christian's point? Should we get feedback from the Firefox UX team?

As I noted in comment 18, like Christian, on my Retina display, I personally preferred 65's font weight with Skia m71 before the SmoothBehavior patch, but these differences are subjective. :)

The patch here is what is used by upstream, and it fixed a legitimate bug in the code, so what you see now is actually how it is supposed to look, and what is being used by Skia upstream/Google/Chrome going forward. The appearance that you saw prior while the bug was in effect was from flat-out wrong gamma-space conversions, so it is behavior that can't be reinstated for that reason.

Subpixel anti-aliasing on macOS, as part of its explicit strategy, includes dilation (i.e. "bolding") to offset some of the perception of thinness caused by subpixel anti-aliasing.

macOS 10.14 decided to remove the subpixel anti-aliasing itself, but keep the dilation. So if you enable font-smoothing in macOS, you will see this bolding. The current recommended way to get rid of this legacy bolding is to disable the OS font-smoothing. The alternative that gives you is the normal grayscale anti-aliasing which never included the dilation.

So if there was a discussion to be had, it should be on the grounds of which of those two - macOS 10.14's legacy font smoothing that produces dilation vs the pre-existing grayscale AA that never dilated - was to be used. Even then, the first concern is which more closely matches Safari.

Flags: needinfo?(lsalzman)
Reporter

Comment 26

4 months ago

On my Retina MacBook Pro, I had to restart my browser (be it Firefox, Safari, or Chrome) to see the "Use font smoothing" change.

Christian told me that he was able to fix the fonts on his non-Retina display by toggling "Use font smoothing" off and on and then rebooting his Mac. Perhaps there is some GPU state on some machines that "Use font smoothing" can't completely reset until macOS reboots? Or maybe Firefox didn't pick up the font changes because it hadn't fully quit first? Either way, we have a workable solution

Paraphrasing Christian's email, the fonts in 66 Nightly still look a bit "bolder" compared to the current Firefox 64 release (which, as mentioned above, is the expected behavior), but it doesn't look wrong anymore (because the blur around the text is gone). 66 now really matches the font rendering of Safari completely and feels correct.

FWIW, I've decided to disable "Use font smoothing" on my MacBook Pro so I can keep using the lighter fonts. :)

Status: RESOLVED → VERIFIED
Reporter

Updated

3 months ago
Depends on: 1524250
Assignee

Updated

3 months ago
Duplicate of this bug: 1472593
Reporter

Updated

3 months ago
Depends on: 1531867
You need to log in before you can comment on or make changes to this bug.